Index: /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/DataView.java
===================================================================
--- /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/DataView.java	(revision 5545)
+++ /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/DataView.java	(revision 5546)
@@ -1,72 +1,86 @@
 package eu.clarin.sru.server.fcs;
 
+/**
+ * This class is used to hold information about a data view that is implemented
+ * by the endpoint.
+ */
 public class DataView {
+    /**
+     * Enumeration to indicate the delivery policy of a data view.
+     */
+    public enum DeliveryPolicy {
+        /**
+         * The data view is sent automatically  by the endpoint.
+         */
+        SEND_BY_DEFAULT,
+        /**
+         * A client must explicitly request the endpoint.
+         */
+        NEED_TO_REQUEST;
+    } // enum PayloadDelivery
+    private final String identifier;
+    private final String mimeType;
+    private final DeliveryPolicy deliveryPolicy;
 
-	public enum PayloadDelivery {
-		SEND_BY_DEFAULT, NEED_TO_REQUEST;
-		
-		@Override
-		public String toString(){
-			String str = super.toString().toLowerCase();
-			return str.replace("_", "-");
-		}
-	}
 
-	public enum PayloadDisposition {
-		INLINE, REFERENCE;
-		
-		@Override
-		public String toString(){
-			return super.toString().toLowerCase();
-		}
-	}
-	
-	private String description;
-	private String mimeType;
-	private String payloadDisposition;
-	private String payloadDelivery;
-	private String shortIdentifier;
-	
-	public DataView() {	}
-	public DataView(String description, String mimeType, 
-			PayloadDisposition payloadDisposition, PayloadDelivery payloadDelivery, 
-			String shortId){
-		this.description = description;
-		this.mimeType = mimeType;
-		this.payloadDisposition = payloadDisposition.toString();
-		this.payloadDelivery = payloadDelivery.toString();
-		this.shortIdentifier = shortId;		
-	}
-	
-	
-	public String getDescription() {
-		return description;
-	}
-	public void setDescription(String description) {
-		this.description = description;
-	}
-	public String getMimeType() {
-		return mimeType;
-	}
-	public void setMimeType(String mimeType) {
-		this.mimeType = mimeType;
-	}
-	public String getPayloadDisposition() {
-		return payloadDisposition;
-	}
-	public void setPayloadDisposition(String payloadDisposition) {
-		this.payloadDisposition = payloadDisposition;
-	}
-	public String getPayloadDelivery() {
-		return payloadDelivery;
-	}
-	public void setPayloadDelivery(String payloadDelivery) {
-		this.payloadDelivery = payloadDelivery;
-	}
-	public String getShortIdentifier() {
-		return shortIdentifier;
-	}
-	public void setShortIdentifier(String shortIdentifier) {
-		this.shortIdentifier = shortIdentifier;
-	}
-}
+    /**
+     * Constructor.
+     *
+     * @param identifier
+     *            a unique short identifier for the data view
+     * @param mimeType
+     *            the MIME type of the data view
+     * @param deliveryPolicy
+     *            the delivery policy for this data view
+     */
+    public DataView(String identifier, String mimeType,
+            DeliveryPolicy deliveryPolicy) {
+        if (identifier == null) {
+            throw new NullPointerException("identifier == null");
+        }
+        if (identifier.isEmpty()) {
+            throw new IllegalArgumentException("identifier is empty");
+        }
+        this.identifier = identifier;
+
+        if (mimeType == null) {
+            throw new NullPointerException("mimeType == null");
+        }
+        if (mimeType.isEmpty()) {
+            throw new IllegalArgumentException("mimeType is empty");
+        }
+        this.mimeType = mimeType;
+
+        if (deliveryPolicy == null) {
+            throw new NullPointerException("deliveryPolicy == null");
+        }
+        this.deliveryPolicy = deliveryPolicy;
+    }
+
+
+    public String getIdentifier() {
+        return identifier;
+    }
+
+
+    public String getMimeType() {
+        return mimeType;
+    }
+
+
+    public DeliveryPolicy getDeliveryPolicy() {
+        return deliveryPolicy;
+    }
+
+
+    @Override
+    public String toString() {
+        StringBuilder sb = new StringBuilder();
+        sb.append(getClass().getSimpleName());
+        sb.append("[");
+        sb.append("identifier=").append(identifier);
+        sb.append(", mimeType=").append(mimeType);
+        sb.append("]");
+        return sb.toString();
+    }
+} // class DataView
Index: /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/EndpointDescription.java
===================================================================
--- /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/EndpointDescription.java	(revision 5546)
+++ /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/EndpointDescription.java	(revision 5546)
@@ -0,0 +1,78 @@
+package eu.clarin.sru.server.fcs;
+
+import java.net.URI;
+import java.util.List;
+
+import eu.clarin.sru.server.SRUException;
+
+
+/**
+ * An interface for abstracting resource endpoint descriptions. This interface
+ * allows you to provide a version of a endpoint description tailored to your
+ * environment.
+ * <p>
+ * The implementation of this interface <em>must</em> be thread-safe.
+ * </p>
+ */
+public interface EndpointDescription {
+    /**
+     * Constant for a (synthetic) persistent identifier identifying the top-most
+     * (= root) resources in the resource inventory.
+     */
+    public static final String PID_ROOT = "root";
+
+    /**
+     * Destroy the resource info inventory. Use this method for any cleanup the
+     * resource info inventory needs to perform upon termination, i.e. closing
+     * of persistent database connections, etc.
+     */
+    public void destroy();
+
+
+    /**
+     * Get the list of capabilities supported by this endpoint. The list
+     * contains the appropriate URIs defined by the CLARIN-FCS specification to
+     * indicate support for certain capabilities. This list <em>must</em> always
+     * contain at least
+     * <code>http://clarin.eu/fcs/capability/basic-search</code> for the
+     * <em>Basic Search</em> capability.
+     * <p>
+     * The implementation of this method <em>must</em> be thread-safe.
+     * </p>
+     *
+     * @return the list of capabilities supported by this endpoint
+     */
+    public List<URI> getCapabilities();
+
+
+    /**
+     * Get the list of data views supported by this endpoint. This list
+     * <em>must</em> always contain an entry for the
+     * <em>Generic Hits (HITS)</em> data view.
+     * <p>
+     * The implementation of this method <em>must</em> be thread-safe.
+     * </p>
+     *
+     * @return the list of data views supported by this endpoint
+     */
+    public List<DataView> getSupportedDataViews();
+
+
+    /**
+     * Get a list of all resources sub-ordinate to a resource identified by a
+     * given persistent identifier.
+     * <p>
+     * The implementation of this method <em>must</em> be thread-safe.
+     * </p>
+     *
+     * @param pid
+     *            the persistent identifier of the superior resource
+     * @return a list of all sub-ordinate ResourceInfo or <code>null</code> if
+     *         not applicable
+     * @throws SRUException
+     *             if an error occurred
+     */
+    public List<ResourceInfo> getResourceList(String pid)
+            throws SRUException;
+
+} // interface EndpointDescription
Index: /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/ResourceInfo.java
===================================================================
--- /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/ResourceInfo.java	(revision 5545)
+++ /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/ResourceInfo.java	(revision 5546)
@@ -9,18 +9,16 @@
  * This class implements a resource info record, which provides supplementary
  * information about a resource that is available at the endpoint.
- * 
- * @see ResourceInfoInventory
+ *
+ * @see EndpointDescription
  */
 public class ResourceInfo {
     private final String pid;
-    @Deprecated
-    private final int resourceCount;
     private final Map<String, String> title;
     private final Map<String, String> description;
     private final String landingPageURI;
     private final List<String> languages;
-    private List<String> availableDataViews;
-    private List<ResourceInfo> subResources;
-    
+    private final List<DataView> availableDataViews;
+    private final List<ResourceInfo> subResources;
+
 
     /**
@@ -29,7 +27,4 @@
      * @param pid
      *            the persistent identifier of the resource
-     * @param resourceCount
-     *            the number of items within the resource or <code>-1</code> if
-     *            not applicable
      * @param title
      *            the title of the resource represented as a map with pairs of
@@ -45,17 +40,19 @@
      *            the languages represented within this resource represented as
      *            a list of ISO-632-3 three letter language codes
+     * @param availableDataViews
+     *            the list of available data views for this resource
      * @param subResources
      *            a list of resource sub-ordinate to this resource or
      *            <code>null</code> if not applicable
      */
-    public ResourceInfo(String pid, int resourceCount,
-            Map<String, String> title, Map<String, String> description,
-            String landingPageURI, List<String> languages,
+    public ResourceInfo(String pid, Map<String, String> title,
+            Map<String, String> description, String landingPageURI,
+            List<String> languages, List<DataView> availableDataViews,
             List<ResourceInfo> subResources) {
         if (pid == null) {
-            throw new NullPointerException("id == null");
+            throw new NullPointerException("pid == null");
         }
         this.pid = pid;
-        this.resourceCount = (resourceCount > 0) ? resourceCount : -1;
+
         if (title == null) {
             throw new NullPointerException("title == null");
@@ -70,4 +67,5 @@
             this.description = null;
         }
+
         this.landingPageURI = landingPageURI;
         if (languages == null) {
@@ -78,28 +76,18 @@
         }
         this.languages = languages;
-        
+
+        if (availableDataViews == null) {
+            throw new IllegalArgumentException("availableDataViews == null");
+        }
+        this.availableDataViews =
+                Collections.unmodifiableList(availableDataViews);
+
         if ((subResources != null) && !subResources.isEmpty()) {
             this.subResources = Collections.unmodifiableList(subResources);
         } else {
             this.subResources = null;
-        }        
+        }
     }
 
-    public ResourceInfo(String pid, int resourceCount,
-            Map<String, String> title, Map<String, String> description,
-            String landingPageURI, List<String> languages,
-            List<String> availableDataViews,
-            List<ResourceInfo> subResources) {
-    	this(pid,resourceCount, title, description, landingPageURI, languages, subResources);
-    	
-    	if (availableDataViews == null){
-        	throw new IllegalArgumentException("available data views == null");
-        }
-        if (availableDataViews.isEmpty()){
-        	throw new IllegalArgumentException("available data views are empty");
-        }
-        this.availableDataViews = availableDataViews;        
-    }
-    
 
     /**
@@ -110,17 +98,4 @@
     public String getPid() {
         return pid;
-    }
-
-
-    /**
-     * Get the number of resources within this resource. If this resource has
-     * sub-ordinate resources, this number should be the sum of all items within
-     * the sub-ordinate resources plus the number of items within this resource.
-     *
-     * @return a number of items or <code>-1</code> if not applicable
-     */
-    @Deprecated
-    public int getResourceCount() {
-        return resourceCount;
     }
 
@@ -217,8 +192,7 @@
 
 
-	public List<String> getAvailableDataViews() {
+	public List<DataView> getAvailableDataViews() {
 		return availableDataViews;
 	}
 
-
 } // class ResourceInfo
